Index: /palm/trunk/SOURCE/poisfft.f90
===================================================================
--- /palm/trunk/SOURCE/poisfft.f90	(revision 1319)
+++ /palm/trunk/SOURCE/poisfft.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -95,56 +101,4 @@
 ! (most of the code is unneeded by check_namelist_files).
 !
-! 763 2011-10-06 09:32:09Z suehring
-! Comment added concerning the last change.
-!
-! 761 2011-10-05 17:58:52Z suehring
-! Bugfix: Avoid divisions by zero in case of using a 'neumann' bc for the
-! pressure at the top of the model domain.
-!
-! 696 2011-03-18 07:03:49Z raasch
-! work_fftx removed from PRIVATE clauses in fftx_tr_xy and tr_yx_fftx
-!
-! 683 2011-02-09 14:25:15Z raasch
-! openMP parallelization for 2d-domain-decomposition
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! ddzu replaced by ddzu_pres due to changes in zu(0)
-!
-! 622 2010-12-10 08:08:13Z raasch
-! optional barriers included in order to speed up collective operations
-!
-! 377 2009-09-04 11:09:00Z raasch
-! __lcmuk changed to __lc to avoid problems with Intel compiler on sgi-ice
-!
-! 164 2008-05-15 08:46:15Z raasch
-! Arguments removed from transpose routines
-!
-! 128 2007-10-26 13:11:14Z raasch
-! Bugfix: wavenumber calculation for even nx in routines maketri
-!
-! 85 2007-05-11 09:35:14Z raasch
-! Bugfix: work_fft*_vec removed from some PRIVATE-declarations
-!
-! 76 2007-03-29 00:58:32Z raasch
-! Tridiagonal coefficients adjusted for Neumann boundary conditions both at
-! the bottom and the top.
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.24  2006/08/04 15:00:24  raasch
-! Default setting of the thread number tn in case of not using OpenMP
-!
-! Revision 1.23  2006/02/23 12:48:38  raasch
-! Additional compiler directive in routine tridia_1dd for preventing loop
-! exchange on NEC-SX6
-!
-! Revision 1.20  2004/04/30 12:38:09  raasch
-! Parts of former poisfft_hybrid moved to this subroutine,
-! former subroutine changed to a module, renaming of FFT-subroutines and
-! -module, FFTs completely substituted by calls of fft_x and fft_y,
-! NAG fft used in the non-parallel case completely removed, l in maketri
-! is now a 1d-array, variables passed by modules instead of using parameter
-! lists, enlarged transposition arrays introduced
-!
 ! Revision 1.1  1997/07/24 11:24:14  raasch
 ! Initial revision
@@ -167,8 +121,16 @@
 !------------------------------------------------------------------------------!
 
-    USE fft_xy
-    USE indices
-    USE transpose_indices
-    USE tridia_solver
+    USE fft_xy,                                                                &
+        ONLY:  fft_init, fft_y, fft_y_1d, fft_y_m, fft_x, fft_x_1d, fft_x_m
+
+    USE indices,                                                               &
+        ONLY:  nnx, nny, nx, nxl, nxr, ny, nys, nyn, nz
+
+    USE transpose_indices,                                                     &
+        ONLY:  nxl_y, nxl_z, nxr_y, nxr_z, nys_x, nys_z, nyn_x, nyn_z, nzb_x,  &
+               nzb_y, nzt_x, nzt_y
+
+    USE tridia_solver,                                                         &
+        ONLY:  tridia_1dd, tridia_init, tridia_substi, tridia_substi_overlap
 
     IMPLICIT NONE
@@ -200,9 +162,12 @@
     SUBROUTINE poisfft_init
 
-       USE arrays_3d,  ONLY:  ddzu_pres, ddzw
+       USE arrays_3d,                                                          &
+           ONLY:  ddzu_pres, ddzw
+
+       USE kinds
 
        IMPLICIT NONE
 
-       INTEGER ::  k
+       INTEGER(iwp) ::  k  !:
 
 
@@ -219,20 +184,45 @@
     SUBROUTINE poisfft( ar )
 
-       USE control_parameters,  ONLY : fft_method, transpose_compute_overlap
-       USE cpulog
+       USE control_parameters,                                                 &
+           ONLY:  fft_method, transpose_compute_overlap
+
+       USE cpulog,                                                             &
+           ONLY:  cpu_log, cpu_log_nowait, log_point_s
+
+       USE kinds
+
        USE pegrid
 
        IMPLICIT NONE
 
-       INTEGER ::  ii, iind, inew, jj, jind, jnew, ki, kk, knew, n, nblk, &
-                   nnx_y, nny_z, nnz_t, nnz_x, nxl_y_bound, nxr_y_bound
-       INTEGER, DIMENSION(4) ::  isave
-
-       REAL, DIMENSION(1:nz,nys:nyn,nxl:nxr) ::  ar
+       INTEGER(iwp) ::  ii           !:
+       INTEGER(iwp) ::  iind         !:
+       INTEGER(iwp) ::  inew         !:
+       INTEGER(iwp) ::  jj           !:
+       INTEGER(iwp) ::  jind         !:
+       INTEGER(iwp) ::  jnew         !:
+       INTEGER(iwp) ::  ki           !:
+       INTEGER(iwp) ::  kk           !:
+       INTEGER(iwp) ::  knew         !:
+       INTEGER(iwp) ::  n            !:
+       INTEGER(iwp) ::  nblk         !:
+       INTEGER(iwp) ::  nnx_y        !:
+       INTEGER(iwp) ::  nny_z        !:
+       INTEGER(iwp) ::  nnz_t        !:
+       INTEGER(iwp) ::  nnz_x        !:
+       INTEGER(iwp) ::  nxl_y_bound  !:
+       INTEGER(iwp) ::  nxr_y_bound  !:
+
+       INTEGER(iwp), DIMENSION(4) ::  isave  !:
+
+       REAL(wp), DIMENSION(1:nz,nys:nyn,nxl:nxr) ::  ar      !:
        !$acc declare create( ar_inv )
-       REAL, DIMENSION(nys:nyn,nxl:nxr,1:nz) ::  ar_inv
-
-       REAL, DIMENSION(:,:,:),   ALLOCATABLE ::  ar1, f_in, f_inv, f_out_y, &
-                                                 f_out_z
+       REAL(wp), DIMENSION(nys:nyn,nxl:nxr,1:nz) ::  ar_inv  !:
+
+       REAL(wp), DIMENSION(:,:,:),   ALLOCATABLE ::  ar1      !:
+       REAL(wp), DIMENSION(:,:,:),   ALLOCATABLE ::  f_in     !:
+       REAL(wp), DIMENSION(:,:,:),   ALLOCATABLE ::  f_inv    !:
+       REAL(wp), DIMENSION(:,:,:),   ALLOCATABLE ::  f_out_y  !:
+       REAL(wp), DIMENSION(:,:,:),   ALLOCATABLE ::  f_out_z  !:
 
 
@@ -723,22 +713,32 @@
 !------------------------------------------------------------------------------!
 
-       USE control_parameters
-       USE cpulog
-       USE indices
+       USE control_parameters,                                                 &
+           ONLY:  host
+
+       USE cpulog,                                                             &
+           ONLY:  cpu_log, log_point_s
+
+       USE kinds
+
        USE pegrid
-       USE transpose_indices
 
        IMPLICIT NONE
 
-       INTEGER            ::  i, iend, iouter, ir, j, k
-       INTEGER, PARAMETER ::  stridex = 4
-
-       REAL, DIMENSION(0:ny,stridex)                    ::  work_ffty
+       INTEGER(iwp)            ::  i            !:
+       INTEGER(iwp)            ::  iend         !:
+       INTEGER(iwp)            ::  iouter       !:
+       INTEGER(iwp)            ::  ir           !:
+       INTEGER(iwp)            ::  j            !:
+       INTEGER(iwp)            ::  k            !:
+
+       INTEGER(iwp), PARAMETER ::  stridex = 4  !:
+
+       REAL(wp), DIMENSION(0:ny,stridex)        ::  work_ffty      !:
 #if defined( __nec )
-       REAL, DIMENSION(0:ny+1,1:nz,nxl:nxr)             ::  work_ffty_vec
+       REAL(wp), DIMENSION(0:ny+1,1:nz,nxl:nxr) ::  work_ffty_vec  !:
 #endif
-       REAL, DIMENSION(1:nz,0:ny,nxl:nxr)            ::  f_in
-       REAL, DIMENSION(nnx,1:nz,nys_x:nyn_x,pdims(1)) ::  f_out
-       REAL, DIMENSION(nxl:nxr,1:nz,0:ny)            ::  work
+       REAL(wp), DIMENSION(1:nz,0:ny,nxl:nxr)             ::  f_in   !:
+       REAL(wp), DIMENSION(nnx,1:nz,nys_x:nyn_x,pdims(1)) ::  f_out  !:
+       REAL(wp), DIMENSION(nxl:nxr,1:nz,0:ny)             ::  work   !:
 
 !
@@ -840,22 +840,32 @@
 !------------------------------------------------------------------------------!
 
-       USE control_parameters
-       USE cpulog
-       USE indices
+       USE control_parameters,                                                 &
+           ONLY:  host
+
+       USE cpulog,                                                             &
+           ONLY:  cpu_log, log_point_s
+
+       USE kinds
+
        USE pegrid
-       USE transpose_indices
 
        IMPLICIT NONE
 
-       INTEGER            ::  i, iend, iouter, ir, j, k
-       INTEGER, PARAMETER ::  stridex = 4
-
-       REAL, DIMENSION(0:ny,stridex)                    ::  work_ffty
+       INTEGER(iwp)            ::  i            !:
+       INTEGER(iwp)            ::  iend         !:
+       INTEGER(iwp)            ::  iouter       !:
+       INTEGER(iwp)            ::  ir           !:
+       INTEGER(iwp)            ::  j            !:
+       INTEGER(iwp)            ::  k            !:
+
+       INTEGER(iwp), PARAMETER ::  stridex = 4  !:
+
+       REAL(wp), DIMENSION(0:ny,stridex)        ::  work_ffty      !:
 #if defined( __nec )
-       REAL, DIMENSION(0:ny+1,1:nz,nxl:nxr)             ::  work_ffty_vec
+       REAL(wp), DIMENSION(0:ny+1,1:nz,nxl:nxr) ::  work_ffty_vec  !:
 #endif
-       REAL, DIMENSION(nnx,1:nz,nys_x:nyn_x,pdims(1)) ::  f_in
-       REAL, DIMENSION(1:nz,0:ny,nxl:nxr)             ::  f_out
-       REAL, DIMENSION(nxl:nxr,1:nz,0:ny)             ::  work
+       REAL(wp), DIMENSION(nnx,1:nz,nys_x:nyn_x,pdims(1)) ::  f_in   !:
+       REAL(wp), DIMENSION(1:nz,0:ny,nxl:nxr)             ::  f_out  !:
+       REAL(wp), DIMENSION(nxl:nxr,1:nz,0:ny)             ::  work   !:
 
 !
@@ -960,19 +970,31 @@
 !------------------------------------------------------------------------------!
 
-       USE control_parameters
-       USE cpulog
-       USE grid_variables
-       USE indices
+       USE control_parameters,                                                 &
+           ONLY:  host
+
+       USE cpulog,                                                             &
+           ONLY:  cpu_log, log_point_s
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx2, ddy2
+
+       USE kinds
+
        USE pegrid
-       USE transpose_indices
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k, m, n, omp_get_thread_num, tn
-
-       REAL, DIMENSION(0:nx)                          ::  work_fftx
-       REAL, DIMENSION(0:nx,1:nz)                     ::  work_trix
-       REAL, DIMENSION(nnx,1:nz,nys_x:nyn_x,pdims(1)) ::  ar
-       REAL, DIMENSION(:,:,:,:), ALLOCATABLE          ::  tri
+       INTEGER(iwp) ::  i                   !:
+       INTEGER(iwp) ::  j                   !:
+       INTEGER(iwp) ::  k                   !:
+       INTEGER(iwp) ::  m                   !:
+       INTEGER(iwp) ::  n                   !:
+       INTEGER(iwp) ::  omp_get_thread_num  !:
+       INTEGER(iwp) ::  tn                  !:
+
+       REAL(wp), DIMENSION(0:nx)                          ::  work_fftx  !:
+       REAL(wp), DIMENSION(0:nx,1:nz)                     ::  work_trix  !:
+       REAL(wp), DIMENSION(nnx,1:nz,nys_x:nyn_x,pdims(1)) ::  ar         !:
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE          ::  tri        !:
 
 
@@ -1091,18 +1113,24 @@
 !------------------------------------------------------------------------------!
 
-       USE control_parameters
-       USE cpulog
-       USE indices
+       USE control_parameters,                                                 &
+           ONLY:  host
+
+       USE cpulog,                                                             &
+           ONLY:  cpu_log, log_point_s
+
+       USE kinds
+
        USE pegrid
-       USE transpose_indices
 
        IMPLICIT NONE
 
-       INTEGER            ::  i, j, k
-
-       REAL, DIMENSION(0:nx,1:nz,nys:nyn)             ::  work_fftx
-       REAL, DIMENSION(1:nz,nys:nyn,0:nx)             ::  f_in
-       REAL, DIMENSION(nny,1:nz,nxl_y:nxr_y,pdims(2)) ::  f_out
-       REAL, DIMENSION(nys:nyn,1:nz,0:nx)             ::  work
+       INTEGER(iwp) ::  i  !:
+       INTEGER(iwp) ::  j  !:
+       INTEGER(iwp) ::  k  !:
+
+       REAL(wp), DIMENSION(0:nx,1:nz,nys:nyn)             ::  work_fftx  !:
+       REAL(wp), DIMENSION(1:nz,nys:nyn,0:nx)             ::  f_in       !:
+       REAL(wp), DIMENSION(nny,1:nz,nxl_y:nxr_y,pdims(2)) ::  f_out      !:
+       REAL(wp), DIMENSION(nys:nyn,1:nz,0:nx)             ::  work       !:
 
 !
@@ -1196,18 +1224,24 @@
 !------------------------------------------------------------------------------!
 
-       USE control_parameters
-       USE cpulog
-       USE indices
+       USE control_parameters,                                                 &
+           ONLY:  host
+
+       USE cpulog,                                                             &
+           ONLY:  cpu_log, log_point_s
+
+       USE kinds
+
        USE pegrid
-       USE transpose_indices
 
        IMPLICIT NONE
 
-       INTEGER            ::  i, j, k
-
-       REAL, DIMENSION(0:nx,1:nz,nys:nyn)             ::  work_fftx
-       REAL, DIMENSION(nny,1:nz,nxl_y:nxr_y,pdims(2)) ::  f_in
-       REAL, DIMENSION(1:nz,nys:nyn,0:nx)             ::  f_out
-       REAL, DIMENSION(nys:nyn,1:nz,0:nx)             ::  work
+       INTEGER(iwp) ::  i  !:
+       INTEGER(iwp) ::  j  !:
+       INTEGER(iwp) ::  k  !:
+
+       REAL(wp), DIMENSION(0:nx,1:nz,nys:nyn)             ::  work_fftx  !:
+       REAL(wp), DIMENSION(nny,1:nz,nxl_y:nxr_y,pdims(2)) ::  f_in       !:
+       REAL(wp), DIMENSION(1:nz,nys:nyn,0:nx)             ::  f_out      !:
+       REAL(wp), DIMENSION(nys:nyn,1:nz,0:nx)             ::  work       !:
 
 !
@@ -1301,19 +1335,31 @@
 !------------------------------------------------------------------------------!
 
-       USE control_parameters
-       USE cpulog
-       USE grid_variables
-       USE indices
+       USE control_parameters,                                                 &
+           ONLY:  host
+
+       USE cpulog,                                                             &
+           ONLY:  cpu_log, log_point_s
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx2, ddy2
+
+       USE kinds
+
        USE pegrid
-       USE transpose_indices
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k, m, n, omp_get_thread_num, tn
-
-       REAL, DIMENSION(0:ny)                          ::  work_ffty
-       REAL, DIMENSION(0:ny,1:nz)                     ::  work_triy
-       REAL, DIMENSION(nny,1:nz,nxl_y:nxr_y,pdims(2)) ::  ar
-       REAL, DIMENSION(:,:,:,:), ALLOCATABLE          ::  tri
+       INTEGER(iwp) ::  i                   !:
+       INTEGER(iwp) ::  j                   !:
+       INTEGER(iwp) ::  k                   !:
+       INTEGER(iwp) ::  m                   !:
+       INTEGER(iwp) ::  n                   !:
+       INTEGER(iwp) ::  omp_get_thread_num  !:
+       INTEGER(iwp) ::  tn                  !:
+
+       REAL(wp), DIMENSION(0:ny)                          ::  work_ffty  !:
+       REAL(wp), DIMENSION(0:ny,1:nz)                     ::  work_triy  !:
+       REAL(wp), DIMENSION(nny,1:nz,nxl_y:nxr_y,pdims(2)) ::  ar         !:
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE          ::  tri        !:
 
 
